<template>
  <coscine-notification-banner
    :visible="isBannerVisible"
    :bannerText1="maintenanceNotices"
    :bannerText2="maintenanceNoticesEnd"
    :linkText="maintenanceLinkText"
    :bannerLink="maintenanceDetailsLink"
    @closeValue="saveVisibility()"
    :dismissable="true"
  />
</template>

<script lang="ts">
import Vue from 'vue';
import { CoscineNotificationBanner } from '@coscine/component-library';
import '@coscine/component-library/dist/index.css';
import { NoticeApi } from '@coscine/api-connection';

export default Vue.extend({
  name: 'MaintenanceBanner',
  components: {
    CoscineNotificationBanner,
  },
  data() {
    return {
      maintenanceNotices: '',
      maintenanceNoticesEnd: '',
      maintenanceLinkText: '',
      maintenanceDetailsLink: '',
      dateString: '',
    };
  },
  computed: {
    isBannerVisible(): boolean {
      return this.$store.state.banner.maintenanceBannerVisible !== this.dateString && this.dateString !== '';
    },
  },
  methods: {
    saveVisibility() {
      this.$store.commit('banner/storeBannerVisibility', { name: 'coscine.maintenanceBanner', state: this.dateString });
    },
    createNotificationText(type: any): any {
      switch (type) {
        case 'Eingriff':
          return this.$t('banner.maintenance.notificationDeployment');
        case 'Störung':
          return this.$t('banner.maintenance.notificationMaintenance');
        case 'Teilstörung':
          return this.$t('banner.maintenance.notificationPartiaMulfunction');
        case 'Unterbrechung':
          return this.$t('banner.maintenance.notificationInteruption');
        case 'eingeschränkt betriebsfähig':
          return this.$t('banner.maintenance.notificationLimitedOperability');
        case 'Wartung':
          return this.$t('banner.maintenance.notificationMaintenance');
        case 'Teilwartung':
          return this.$t('banner.maintenance.notificationPartialMaintenance');
        default:
          return this.$t('banner.maintenance.notificationDefaultText');
      }
    },
    createNotificationEndText(type: any): any {
      if(type == "Eingriff"){
        return "";
      }
      else{
        return this.$t("banner.maintenance.notificationEndText");
      }
    },
    createNotificationLinkText(type: any): any {
      if(type == "Eingriff"){
        return "";
      }
      else{
        return this.$t("banner.maintenance.moreInformation");
      }
    },
  },
  created() {
    NoticeApi.GetMaintenance((response: any) => {
      if (response.data.startsDate !== null && response.data.startsDate !== undefined) {
        var now = new Date(Date.now());
        var startDate = new Date(response.data.startsDate);
        var endDate = response.data.endsDate;
        if (startDate <= now && (endDate === null || new Date(endDate) >= now)) {
          this.dateString = response.data.startsDate + response.data.endsDate;
          this.maintenanceDetailsLink = response.data.url;
          this.maintenanceNotices = this.createNotificationText(response.data.type);
          this.maintenanceNoticesEnd = this.createNotificationEndText(response.data.type);
          this.maintenanceLinkText = this.createNotificationLinkText(response.data.type);
        }
      }
    });
  },
});
</script>
